package io.tswf.minecraft.blockventure.core.transmutation

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.ClassReference
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.MethodDescription
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.Self
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.Transmute
import io.tswf.minecraft.blockventure.core.view.ViewBlockEntityType
import net.minecraft.block.entity.BlockEntity
import net.minecraft.block.entity.BlockEntityType

@CompileStatic
class TransmutationBlockEntityType {

    @Transmute(
            targetClass = @ClassReference(BlockEntityType),
            targetMethod = @MethodDescription(
                    name = "<init>",
                    descriptor = "()V"
            )
    )
    static void makeBlocksListMutable(@Self BlockEntityType self) {
        def blockEntityTypeView = (ViewBlockEntityType) self
        blockEntityTypeView.blocks = new HashSet<>(blockEntityTypeView.blocks)
    }
}
